// =========================== MSP430F1xxx Ŭ  α׷ =================
//  CPU : MSP430F1611
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(3.6864MHz)
//            SMCLK: DCO(3.6864MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x16x.h"
#include <stdio.h>

//  
#define		DELTA_1	900					// DCO = DELATA_1 * 4096 = 3.6864MHz
#define		DELTA_2	250					// DCO = DELATA_2 * 4096 = 1.024000MHz
#define		DELTA_3	64					// DCO = DELATA_3 * 4096 = 0.262144MHz

#define		DELTA	DELTA_1					// DCO = 3.6864MHz

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void Set_DCO(void);						// DCO 

//  

// ===============================  α׷ ==============================
// [μ]: void
// []: P1.0 : PULSE Output
//         P5.4 : MCLK  Output
//         P5.5 : SMCLK Output
//         P5.6 : ACLK  Output
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	P1DIR |= 0x01;						// P1.0 output
	P5DIR |= 0x70;						// P5.4-6 output
	P5SEL |= 0x70;						// P5.4-6 SMCLK,ACLK output
	while(1){
		P1OUT ^= 0x01;					// Toggle P1.0
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	
// XTX  : Low Freqency
// DIVx : ACLK(4.096Khz) = LXFTCLK(32.768KHz) / 8
	BCSCTL1 = XT2OFF | DIVA1 | DIVA0;
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 
	Set_DCO();						// DCO 

// DIVx : ACLK = LXFTCLK(32.768KHz) / 1
	BCSCTL1 &= ~(DIVA1 | DIVA0);
}

// =================================== DCO  ===============================
// [μ] void
// ----------------------------------------------------------------------------
void Set_DCO(void)
{
unsigned int Compare, Oldcapture = 0;

// CMx  : Capture on rising edge(01)
// CCISx: CCIxB(01)
// CAP  : Capture Mode(1)
	CCTL2 = CCIS0 + CM0 + CAP;				// Define CCR2, CAP, ACLK

// TASSELx : Timer Clock Source ACLK(01)
// TACLR : TimerA Clear
// MCx   : Continuos mode : The timer counts up to 0xffffh(10)
	TACTL = TASSEL1 + TACLR + MC1;				// SMCLK, continous mode
	while(1){
		while (!(CCIFG & CCTL2));			// Wait until capture occured
		CCTL2 &= ~CCIFG;				// Capture occured, clear flag
		Compare = CCR2;					// Get current captured SMCLK
		Compare = Compare - Oldcapture;			// SMCLK difference
		Oldcapture = CCR2;				// Save current captured SMCLK
		if(DELTA == Compare){
			break;					// if equal, leave "while(1)"
		}
		else if(DELTA < Compare){			// DCO is too fast, slow it down
			DCOCTL--;
			if (DCOCTL == 0xFF){
				if (!(BCSCTL1 == (XT2OFF + DIVA_3)))
				BCSCTL1--;			// Did DCO roll under?, Sel lower RSEL
			}
		}
		else{
			DCOCTL++;
			if(DCOCTL == 0x00){
				if (!(BCSCTL1 == (XT2OFF + DIVA_3 + 0x07)))
				BCSCTL1++;			// Did DCO roll over? Sel higher RSEL
			}
		}
	}
	CCTL2 = 0;						// Stop CCR2
	TACTL = 0;						// Stop Timer_A
}
