// ======================== MSP430F1xxx D/A ͸  ======================
//  CPU : MSP430F1611
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(4.8MHz)
//            SMCLK: DCO(4.8MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x16x.h"
#include <stdio.h>

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void dac_set(void);						// DAC 

//  

// ===============================  α׷ ==============================
// [μ]: void
// [] D/A Output 12Bit DAC0(P6.6) : 0-2.5V Ref( )
// ---------------------------------------------------------------------------
int main(void)
{
unsigned datau =0;
	
	cpu_setup();						// cpuʱȭ
	dac_set();						// DAC 
	_EINT();						// Enable interrupts

	while(1){
		DAC12_0DAT = datau++;				// DAC Output Data
		if(datau >= 4095U) datau = 0;
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000; dly++) ;			// XTAL  ð 
	
// Rsel = 7, DCO = 7, MOD = 0, DCOR = 0 TA = 25 :: DCO ִ ļ (4.4 - 5.4Mhz)
// XTX  : Low Freqency
// DIVx : ACLK = LXFTCLK(32.768KHz)
// Register Select : 7
	BCSCTL1 = XT2OFF + RSEL2 + RSEL1 + RSEL0;
	DCOCTL = 0xe0;						// DCO Max Freqency
}

// ============================== ADC10  ==================================
// [μ] void
// [] DAC Output : 0-2.5V Ref
// ----------------------------------------------------------------------------
void dac_set(void)
{
	ADC12CTL0 = REF2_5V + REFON;				// Internal 2.5V ref on
	DAC12_0CTL = DAC12IR + DAC12AMP_5 + DAC12ENC;		// Internal ref gain 1
}
