// ================== MSP430F1xxx A/D12 ͸ LED ǥ ===================
//  CPU : MSP430F1611
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(4.8MHz)
//            SMCLK: DCO(4.8MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <stdio.h>
#include <signal.h>
#include <iomacros.h>

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void adc12_set(void);						// ADC12 

//  
volatile unsigned adc12_data;					// analog12 interrupt data
volatile int adc12_int_flg = 0;					// analog12 interrupt flag

// ===============================  α׷ ==============================
// [μ]: void
// [] UART ACLK(32.768KHz) 
//        A/D Input 12Bit A0(P6.0) : 0 - AVcc(Է ) 
//        A0 > 1.499V(1861) -> LED(P1.0 = 0) ON
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	adc12_set();						// ADC12 
	P1DIR |= 0x01;						// Set P1.0 to output direction
	P1OUT |= 0x01;						// P1.0 = 0 :: LED OFF
	_EINT();						// Enable interrupts

	while(1){
		adc12_int_flg = 0;
		ADC12CTL0 |= ADC12SC;				// Start conversion
		while(adc12_int_flg == 0);			// a/d conversion Ϸ 
		if(adc12_data > 1861) P1OUT &= ~0x01;		// P1.0 = 1 :: LED ON
		else P1OUT |= 0x01;				// P1.0 = 0 :: LED OFF
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000; dly++) ;			// XTAL  ð 
	
// Rsel = 7, DCO = 7, MOD = 0, DCOR = 0 TA = 25 :: DCO ִ ļ (4.4 - 5.4Mhz)
// XTX  : Low Freqency
// DIVx : ACLK = LXFTCLK(32.768KHz)
// Register Select : 7
	BCSCTL1 = XT2OFF + RSEL2 + RSEL1 + RSEL0;
	DCOCTL = 0xe0;						// DCO Max Freqency
}

// ============================== ADC10  ==================================
// [μ] void
// [] VR+ : AVcc, VR- = AVss
// ----------------------------------------------------------------------------
void adc12_set(void)
{
// SHT1x     : ADC12CLK / 4
// ADC12ON   : ADC12 on
	ADC12CTL0 = SHT0_2 + ADC12ON;				// Set sampling time, turn on ADC12
// SHP : ON
	ADC12CTL1 = SHP;					// Use sampling timer
// ADC12 Interrupt ADC12IE0 : ON
	ADC12IE = 0x01;						// Enable interrupt
// ADC12SC : Start Conversion
	ADC12CTL0 |= ENC;					// Conversion enabled
// ADC0 PORT Enable
	P6SEL |= 0x01;						// P6.0 ADC option select
}

// ============================== ADC12 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt (ADC12_VECTOR)ADC12_ISR(void)
{
	adc12_data = ADC12MEM0;					// Move results, IFG is cleared
	adc12_int_flg = 1;					// a/d data flag on
}
