// ==================== MSP430F1xxx UART1_ACLK  α׷ =================
//  CPU : MSP430F1611
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(4.9MHz)
//            SMCLK: DCO(4.9MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <stdio.h>
#include <signal.h>
#include <iomacros.h>

// Լ 
void cpu_setup(void);						// CPU ʱȭ

void com_set(long baud);					//  
int putchar(int c);						// printf() Լ ϱ  Լ
void putchar_1(unsigned char datac);				//  1Ʈ ۽
void puts_1(unsigned char dbuf[]);				//  ڿ 

//  
volatile unsigned char com1_rx_data;				// UART1  
volatile int com1_rx_eflg = 0;					// UART1  ͷƮ Ϸ ÷

// ===============================  α׷ ==============================
// [μ]: void
// [] UART ACLK(32.768KHz) 
// ---------------------------------------------------------------------------
int main(void)
{
int datai = 1345;
	
	cpu_setup();						// cpuʱȭ
	com_set(9600);						//  
	_EINT();						// Enable interrupts

	puts_1("serial test program\r\n");			// string tx
	printf("%s : %d\r\n","test printf",datai);
	while(1){
		if(com1_rx_eflg){				// UART1  Ϸ
			putchar_1(com1_rx_data);		// ۽
			com1_rx_eflg = 0;			// ͷƮ ÷ Clear
		}
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000; dly++) ;			// XTAL  ð 
	
// Rsel = 7, DCO = 7, MOD = 0, DCOR = 0 TA = 25 :: DCO ִ ļ (4.4 - 5.4Mhz)
// XTX  : Low Freqency
// DIVx : ACLK = LXFTCLK(32.768KHz)
// Register Select : 7
	BCSCTL1 = XT2OFF + RSEL2 + RSEL1 + RSEL0;
	DCOCTL = 0xe0;						// DCO Max Freqency
}

// ================================   =================================
// [μ] long baud
// Item1: Ʈ (300 - 9600Bps)
// [] ACLK(32.768KHz)
// ----------------------------------------------------------------------------
void com_set(long baud)
{
// UART Mode,8Bit Data, NON Parity, 1 STOP
	UCTL1 = CHAR;
	UTCTL1 = SSEL0;						// Source Clock UCLK = ACLK
	switch(baud){
		case 1200: UBR01 = 0x1b;			// Baud Rate Register Low
			   UBR11 = 0x00;			// Baud Rate Register High
			   UMCTL1 = 0x03;			// Modulation Control Register
			   break;
		case 2400: UBR01 = 0x0d;			// Baud Rate Register Low
			   UBR11 = 0x00;			// Baud Rate Register High
			   UMCTL1 = 0x6b;			// Modulation Control Register
			   break;
		case 4800: UBR01 = 0x06;			// Baud Rate Register Low
			   UBR11 = 0x00;			// Baud Rate Register High
			   UMCTL1 = 0x6f;			// Modulation Control Register
			   break;
		case 9600: UBR01 = 0x03;			// Baud Rate Register Low
			   UBR11 = 0x00;			// Baud Rate Register High
			   UMCTL1 = 0x4a;			// Modulation Control Register
			   break;
	}
	ME2 |= UTXE1 + URXE1;					// Enabled USART0 TXD/RXD
	IE2 |= URXIE1;						// Enabled USART0 RX interrupt
	P3SEL |= 0xc0;						// P3.4,5 = USART0 TXD/RXD
	P3DIR |= 0x40;						// P3.4 output direction
}

// =============================== 1 Ʈ ۽ ==============================
// [μ] int c
// Item1:  (0 - ffh)
// [] printf()Լ  putchar() .
// ----------------------------------------------------------------------------
int putchar(int c)
{
	while(!(IFG2 & UTXIFG1));				// USART0 TX buffer ready?
	TXBUF1 = c;						// RXBUF0 = send data
	return(c);
}

// =============================== 1Ʈ ۽ ===============================
// [μ] unsigned char datac
// Item1:  (0 - ffh)
// ----------------------------------------------------------------------------
void putchar_1(unsigned char datac)
{
	while(!(IFG2 & UTXIFG1));				// USART0 TX buffer ready?
	TXBUF1 = datac;						// RXBUF0 = send data
}

// ================================ Ʈ ۽ ===============================
// [μ] unsigned char dbuf
// Item1:   ڿ
// ----------------------------------------------------------------------------
void puts_1(unsigned char dbuf[])
{
unsigned char ch;
int i = 0;

	ch = dbuf[i++];
	while(ch != 0){
		putchar_1(ch);					// 1 send
		ch = dbuf[i++];
	}
}

// ============================== UART1 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt (UART1RX_VECTOR)usart1_rx(void)
{
	com1_rx_data = RXBUF1;					//   
	com1_rx_eflg = 1;					//  Ϸ ÷ SET
}
