// ======================= MSP430F1xxx TEXT LCD α׷ =====================
//  CPU : MSP430F1611
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(4.8MHz)
//            SMCLK: DCO(4.8MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <stdio.h>
#include <signal.h>
#include <iomacros.h>

// LCD  
#define	SCREEN1		0
#define	SCREEN2		1

#define	OFF		0
#define	ON		1

// Լ 
void cpu_setup(void);						// CPU ʱȭ

void main_menu_disp(void);					//  ޴ ǥ

void com_set(long baud);					//  
int putchar(int c);						// printf() Լ ϱ  Լ
void putchar_0(unsigned char datac);				//  1Ʈ ۽
void puts_0(unsigned char dbuf[]);				//  ڿ 

// LCD 
void Clrscr(void);						// ȭ 

void Cursor_Set(char sts);					// Ŀ  
void Gotoxyt(char x, char y);					// ؽƮ ǥ

void Putch(char data);						// 1 ǥ
void Putchxyt(char x, char y,char data);			// ؽƮ ǥ  ǥ

void Puts(char stbuf[]);					// LCD ڿ 		
void Putsxyt(char x, char y,char dbuf[]);			// ؽƮ ǥ ڿ ǥ

void LCD_Init(void);						// GLCD Init
void LCD_Busy(void);						// LCD Busy Check
void LCD_Command(unsigned char uch);				// COMMAND Write
void LCD_Dwrite(unsigned char uch);				// DATA Write

void LCD_delay(int cnt);					// LCD ð  Լ

//  
volatile unsigned char com0_rx_data;				// UART0  
volatile int com0_rx_eflg = 0;					// UART0  ͷƮ Ϸ ÷

// ===============================  α׷ ==============================
// [μ]: void
// [] UART ACLK(32.768KHz) 
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	com_set(9600);						//  
	_EINT();						// Enable interrupts
	LCD_Init();						// LCD ʱȭ
	main_menu_disp();					//  ޴ ǥ
	
	Putsxyt(1,1,"   MSP430 TLCD  ");
	Putsxyt(1,2,"www.cpuplaza.com");
	while(1){
		if(com0_rx_eflg){				// COM1  ˻
			if(com0_rx_data == '1') Clrscr();	// ȭ 
			else if(com0_rx_data == '2') Putch('1');// 1 ǥ
			else if(com0_rx_data == '3') Putchxyt(1,1,'3');// ؽƮ ǥ 1 ǥ
			else if(com0_rx_data == '4') Puts("123");// ڿ ǥ
			else if(com0_rx_data == '5'){		// ؽƮ ǥ ڿ ǥ
				Putsxyt(1,1,"LCD TEST LINE1");
				Putsxyt(1,2,"LCD TEST LINE2");
			}
			else if(com0_rx_data == '6') Cursor_Set(ON);// Ŀ ON
			else if(com0_rx_data == '7') Cursor_Set(OFF);// Ŀ OFF
			else putchar(com0_rx_data);
			com0_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========== LCD Test Main =========\r\n");
	printf("- 1 : Clrscr                     -\r\n");
	printf("- 2 : Putch                      -\r\n");
	printf("- 3 : Putchxyt                   -\r\n");
	printf("- 4 : Puts                       -\r\n");
	printf("- 5 : Putsxyt                    -\r\n");
	printf("- 6 : Cursor ON                  -\r\n");
	printf("- 7 : Cursor OFF                 -\r\n");
	printf("----------------------------------\r\n");
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000; dly++) ;			// XTAL  ð 

// Port4 : TEXT LCD Data Bus
	P4DIR = 0xff;						// Port1 ALL Output 
// Port5.0 : TEXT LCD RS
// Port5.1 : TEXT LCD R/W
// Port5.2 : TEXT LCD E
// Port3.3 : MAX3221 : FORCEOFF : ShotDowb(0)
	P3OUT |= 0x08;						// MAX3221 FORCE OFF = 1
	P3DIR = 0x08;						// Port3.3 Output 
	P5OUT &= ~0x07;						// TEXT LCD RS = R/W\ = E = 0
	P5DIR = 0x07;						// Port5.0,1,2 Output 
	
// Rsel = 7, DCO = 7, MOD = 0, DCOR = 0 TA = 25 :: DCO ִ ļ (4.4 - 5.4Mhz)
// XTX  : Low Freqency
// DIVx : ACLK = LXFTCLK(32.768KHz)
// Register Select : 7
	BCSCTL1 = XT2OFF + RSEL2 + RSEL1 + RSEL0;
	DCOCTL = 0xe0;						// DCO Max Freqency
}

// ================================   =================================
// [μ] long baud
// Item1: Ʈ (300 - 9600Bps)
// [] ACLK(32.768KHz)
// ----------------------------------------------------------------------------
void com_set(long baud)
{
// UART Mode,8Bit Data, NON Parity, 1 STOP
	UCTL0 = CHAR;
	UTCTL0 = SSEL0;						// Source Clock UCLK = ACLK
	switch(baud){
		case 1200: UBR00 = 0x1b;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x03;			// Modulation Control Register
			   break;
		case 2400: UBR00 = 0x0d;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x6b;			// Modulation Control Register
			   break;
		case 4800: UBR00 = 0x06;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x6f;			// Modulation Control Register
			   break;
		case 9600: UBR00 = 0x03;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x4a;			// Modulation Control Register
			   break;
	}
	ME1 |= UTXE0 + URXE0;					// Enabled USART0 TXD/RXD
	IE1 |= URXIE0;						// Enabled USART0 RX interrupt
	P3SEL |= 0x30;						// P3.4,5 = USART0 TXD/RXD
	P3DIR |= 0x10;						// P3.4 output direction
}

// =============================== 1 Ʈ ۽ ==============================
// [μ] int c
// Item1:  (0 - ffh)
// [] printf()Լ  putchar() .
// ----------------------------------------------------------------------------
int putchar(int c)
{
	while(!(IFG1 & UTXIFG0));				// USART0 TX buffer ready?
	TXBUF0 = c;						// RXBUF0 = send data
	return(c);
}

// =============================== 1Ʈ ۽ ===============================
// [μ] unsigned char datac
// Item1:  (0 - ffh)
// ----------------------------------------------------------------------------
void putchar_0(unsigned char datac)
{
	while(!(IFG1 & UTXIFG0));				// USART0 TX buffer ready?
	TXBUF0 = datac;						// RXBUF0 = send data
}

// ================================ Ʈ ۽ ===============================
// [μ] unsigned char dbuf
// Item1:   ڿ
// ----------------------------------------------------------------------------
void puts_0(unsigned char dbuf[])
{
unsigned char ch;
int i = 0;

	ch = dbuf[i++];
	while(ch != 0){
		putchar_0(ch);					// 1 send
		ch = dbuf[i++];
	}
}

// ============================== UART0 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt (UART0RX_VECTOR)usart0_rx(void)
{
	com0_rx_data = RXBUF0;					//   
	com0_rx_eflg = 1;					//  Ϸ ÷ SET
}

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char sts
// Item1: Ŀ (0,(OFF),1(ON))
// Item2: Ŀ ǥ ġ(SCREEN0,SCREEN1)
/// ----------------------------------------------------------------------------
void Cursor_Set(char sts)
{
	if(sts == OFF) LCD_Command(0x0c);			// CURSOR OFF/BLINK OFF
	else LCD_Command(0x0f);					// CURSOR ON/BLINK ON(0x0e)
}

// ================================ ȭ Ұ ==================================
// [μ] void
/// ----------------------------------------------------------------------------
void Clrscr(void)
{
	LCD_Command(0x01);					// ALL CLEAR
}

// =========================== ؽƮ Ŀ ġ  ============================
// [μ] char x,char y
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
/// ----------------------------------------------------------------------------
void Gotoxyt(char x, char y)
{
char xx = x-1,yy = y-1;

	LCD_Busy();
	switch(yy){
		case 0: LCD_Command(0x80+xx); break;  
		case 1: LCD_Command(0xc0+xx); break;
	}
}

// ==================================  ǥ ================================
// [μ] char data
// Item1: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putch(char data)
{
	LCD_Dwrite(data);					//  ǥ
}

// ============================  ġ  ǥ ===========================
// [μ] char x,char y,char data
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putchxyt(char x, char y,char data)
{
	Gotoxyt(x,y);						// ǥ 
	LCD_Dwrite(data);					//  ǥ
}

// ============================= LCD1 ڿ  ===========================
// [μ] char str[]
// Item1: ɾ
// ----------------------------------------------------------------------------
void Puts(char stbuf[])
{
char *pstr = 0;

	pstr = stbuf;
	while(*pstr) LCD_Dwrite(*pstr++);			// ڿ 
}

// ===========================  ġ ڿ ǥ =========================
// [μ] char x,char y,char dbuf[]
// Item1: ǥ xǥ(1-16)
// Item2: ǥ yǥ(1-2)
// Item3: ǥ ڿ
/// ----------------------------------------------------------------------------
void Putsxyt(char x, char y,char dbuf[])
{
	Gotoxyt(x,y);						// ǥ 
	Puts(dbuf);						// ڿ ǥ
}

// ================================= LCD ʱȭ ===============================
// [μ] void
// ----------------------------------------------------------------------------
void LCD_Init(void)
{
	LCD_delay(50);
	LCD_Command(0x38);
	LCD_delay(100);
	LCD_Command(0x38);
	LCD_delay(200);
	LCD_Command(0x38);					// FUNCTION SET
	LCD_Command(0x0c);					// DISP ON/CURSOR/BLINK ON
	LCD_Command(0x06);					// ENTRY MODE
	
	LCD_Command(0x01);					// ALL CLEAR
	LCD_delay(100);
}

// =================================== BUSY Check ============================
// [μ] void
// ---------------------------------------------------------------------------
void LCD_Busy(void)
{
unsigned dly;

	for(dly = 0; dly < 28000; dly++);			// delay 1ms
}

// ============================== COMMAND  write =======================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Command(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check

	P5OUT &= ~0x04;						// PORT3.2 :: LCD_E = 0
	P5OUT &= ~0x01;						// PORT3.0 :: LCD RS = 0 :: Instruction Set
	P5OUT &= ~0x02;						// PORT3.1 :: LCD_R/W\ = Write	
	P4OUT = uch;						// PORTA = uch
	P5OUT |= 0x04;						// PORT3.2 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	P5OUT &= ~0x04;						// PORT3.2 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  write ==========================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void LCD_Dwrite(unsigned char uch)
{
int i;

	LCD_Busy();						// BUSY Check

	P5OUT &= ~0x04;						// PORT3.2 :: LCD_E = 0
	P5OUT |= 0x01;						// PORT3.0 :: LCD RS = 1 :: Data Set
	P5OUT &= ~0x02;						// PORT3.1 :: LCD_R/W\ = Write	
	P4OUT = uch;						// PORTA = uch
	P5OUT |= 0x04;						// PORT3.2 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	P5OUT &= ~0x04;						// PORT3.2 :: LCD_E = 0
	for(i = 0; i < 3; i++);					// delay
}


// ================================= LCD DELAY ===============================
// [μ] int cnt
// Item1: cnt * 1ms
// ---------------------------------------------------------------------------
void LCD_delay(int cnt)
{
unsigned i,dly;

	for(i = 0; i < cnt; i++){
		for(dly = 0; dly < 28000; dly++);		// delay 1ms
	}
}
