// ======================= MSP430F1xxx GRAP LCD α׷ =====================
//  CPU : MSP430F1611
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : mspgcc+Dev-C++
// [ ]  : Grap LCD TM0027-Z(128*64 Dot)
//            ACLK : 32.768Khz
//            MCLK : DCO(4.8MHz)
//            SMCLK: DCO(4.8MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <iomacros.h>

// Ʈ
#include "eng8x16.fnt"
#include "han16x16.fnt"
// ϼ ->  ȯ ̺
#include "hconvtbl.inc"

//  
#define 	_BLACK		0
#define 	_WHITE		15

// LCD  

#define DISPLAY_ON		0xAF				// Display On
#define DISPLAY_OFF		0xAE				// Display Off
#define START_LINE		0x40				// 0x40 ~ 0x7F
#define PAGE_ADDRESS		0xB0				// 0xB0 ~ 0xB8
#define COLUMN_ADDRESS_LO	0x00				// 0x00 ~ 0x0F
#define COLUMN_ADDRESS_HI	0x10				// 0x10 ~ 0x1F
#define HORIZONTAL_NORMAL	0xA0
#define HORIZONTAL_REVERSE	0xA1
#define DISPLAY_NORMAL		0xA6
#define DISPLAY_INVERSE		0xA7
#define ALL_POINT_OFF		0xA4
#define ALL_POINT_ON		0xA5
#define LCD_BIAS_1OF9		0xA2
#define LCD_BIAS_1OF7		0xA3
#define R_M_W_MODE		0xE0
#define R_M_W_MODE_END		0xEE
#define LCD_RESET		0xE2
#define VERTICAL_NORMAL		0xC0
#define VERTICAL_REVERSE	0xC8
#define ALL_POWER_OFF		0x28
#define ALL_POWER_ON		0x2F
#define V5_VOLTAGE_RATIO	0x20				// 0x20 ~ 0x27
#define LCD_CONTRAST		0x81				// + 0x01 ~ 0x3F

#define STATUS_BUSY		0x80
#define STATUS_ADC		0x40
#define STATUS_ON_OFF		0x20
#define STATUS_RESET		0x10

// Լ 
void cpu_setup(void);						// CPU ʱȭ

void main_menu_disp(void);					//  ޴ ǥ

void com_set(long baud);					//  
int putchar(int c);						// printf() Լ ϱ  Լ
void putchar_0(unsigned char datac);				//  1Ʈ ۽
void puts_0(unsigned char dbuf[]);				//  ڿ 

// LCD 
void Clrscr(void);						// ü ȭ 
void Cleardevice(void);						// ü ȭ 
void Gotoxy(int x,int y);					// ׷ ǥ 
void Gotoxyt(int x,int y);					// ؽƮ ǥ 

void Setcolor(char color);					// ڻ (_WHITE,_BLACK)
void Backlight_Ctrl(char sts);					// LCD BACKlight ON/OFF

void Putch(unsigned c); 					// ڸ 
void Putchxy(int x,int y,unsigned c);				// ׷ ǥ  
void Putchxyt(int x,int y,unsigned c);				// ؽƮ ǥ  

void Puts(const char *str);					// ڿ 
void Putsxy(int x,int y,const char *str);			// ׷ ǥ ڿ 
void Putsxyt(int x,int y,const char *str);			// ؽƮ ǥ ڿ 

void Line(int x1,int y1,int x2,int y2);				// ׷ǥ  ׸
void Rectangle(int x1,int y1,int x2,int y2);			// ׷ ǥ ڽ ׸
void Rectanglefill(int x1,int y1,int x2,int y2);		// ä ڽ ׸
void Circle(int xx,int yy,int radius);				//  ׸
void Ellipse(int xx,int yy,int a0,int b0);			// Ÿ ׸

void Putpixel(int x,int y,char color);				// ȭ鿡  (,,÷(_WHITE,BLACK))
void Putpixelb(int x,int y,unsigned char datac,char color);	// ȭ鿡 Ʈ 

void symmetry4(int xx,int yy,int x,int y);
void _Plotcircle(int xx,int yy,int x,int y);

void _Putch(unsigned int c);					// 1Ʈ  
void *_GetHanImage(unsigned c);					// ѱ Ʈ ε
void _memor(unsigned char *s1,const unsigned char *s2, int len);// ѱ Ʈ 
unsigned char* _GetAscImage(int c);		        	//  Ʈ  ε
void Han_Conv(char *buf);					// ϼ(SRAM)  (SRAM) ȯ

// LCD H/W 
void GLCD_Init(void);						// GLCD Init
void GLCD_Busy(void);						// LCD Busy Check
void GLCD_Command(unsigned char uch);				// COMMAND Write
void GLCD_Dwrite(unsigned char uch);				// DATA Write
unsigned char GLCD_Dread(void);					// DATA 
void LCD_delay(int cnt);					// LCD ð  Լ

//  
volatile unsigned char com0_rx_data;				// UART0  
volatile int com0_rx_eflg = 0;					// UART0  ͷƮ Ϸ ÷

int _screen_color = _WHITE;					// ڻ 
int _screen_curx = 0;						// X ǥ 
int _screen_cury = 0;						// Yǥ 

static unsigned char ib[32];					// ѱ  
static unsigned char ascii_fbuf[20];                            //    
static unsigned char han_conv_buf[101];				// ѱ    

// ===============================  α׷ ==============================
// [μ]: void
// [] UART ACLK(32.768KHz)  9600Bps,N,8,1
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	com_set(9600);						//  
	_EINT();						// Enable interrupts
	GLCD_Init();						// LCD ʱȭ
	main_menu_disp();					//  ޴ ǥ

	Putsxyt(1,1,"ϼ ѱ TEST");				// ׷ ǥ ڿ ǥ
	Putsxyt(1,2,"www.cpuplaza.com");				// ׷ ǥ ڿ ǥ
	while(1){
		if(com0_rx_eflg){				// COM1  ˻
			if(com0_rx_data == '0') main_menu_disp();//  ޴ ǥ
			else if(com0_rx_data == '1') Clrscr();	// ȭ 
			else if(com0_rx_data == '2') Cleardevice();// ȭ 
			else if(com0_rx_data == '3') Putpixel(0,0,_WHITE);// ȼ ǥ
			else if(com0_rx_data == '4') Putpixelb(0,1,0xff,_WHITE);// Ʈ  ǥ()
			else if(com0_rx_data == '5') Putch('1');	// 1 ǥ
			else if(com0_rx_data == '6') Putchxy(16,2,'2');	// ׷ ǥ 1 ǥ
			else if(com0_rx_data == '7') Putchxyt(8,3,'3');	// ؽƮ ǥ 1 ǥ
			else if(com0_rx_data == '8') Puts("");	// ڿ ǥ
			else if(com0_rx_data == '9') Putsxy(10,3,"׽Ʈ");// ׷ ǥ ڿ ǥ
			else if(com0_rx_data == 'a') Putsxyt(4,2,"׽Ʈ");// ؽƮ ǥ ڿ ǥ
			else if(com0_rx_data == 'b'){			//  پϰ ׸
				Line(0,0,127,0);			// 簢 ڽ
				Line(127,0,127,63);
				Line(127,63,0,63);
				Line(0,0,0,63);

				Line(0,32,127,32);			// +
				Line(64,0,64,63);

				Line(0,0,127,63);			// 밢
				Line(0,63,127,0);
			}
			else if(com0_rx_data == 'c') Rectangle(10,10,118,54);// 簢ڽ ׸
			else if(com0_rx_data == 'd') Rectanglefill(10,10,118,54);// ä 簢ڽ ׸
			else if(com0_rx_data == 'e') Circle(64,32,10);	//  ׸
			else if(com0_rx_data == 'f') Ellipse(64,32,20,10);// Ÿ ׸
			else if(com0_rx_data == 'g') Setcolor(_WHITE);	//   WHITE
			else if(com0_rx_data == 'h') Setcolor(_BLACK);	//   BLACK
			else if(com0_rx_data == 'i') Backlight_Ctrl(1);	// LCD BACKlight ON
			else if(com0_rx_data == 'j') Backlight_Ctrl(0);	// LCD BACKlight OFF
			else putchar(com0_rx_data);
			com0_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ] void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("%s","========== LCD Test Main =========\r\n");
	printf("%s","- 0 : Main Menu Disp             -\r\n");
	printf("%s","- 1 : Clrscr                     -\r\n");
	printf("%s","- 2 : Cleardevice                -\r\n");
	printf("%s","- 3 : Putpixel                   -\r\n");
	printf("%s","- 4 : Putpixelb                  -\r\n");
	printf("%s","- 5 : Putch                      -\r\n");
	printf("%s","- 6 : Putchxy                    -\r\n");
	printf("%s","- 7 : Putchxyt                   -\r\n");
	printf("%s","- 8 : Puts                       -\r\n");
	printf("%s","- 9 : Putsxy                     -\r\n");
	printf("%s","- a : Putsxyt                    -\r\n");
	printf("%s","- b : Line                       -\r\n");
	printf("%s","- c : Rectangle                  -\r\n");
	printf("%s","- d : Rectanglefill              -\r\n");
	printf("%s","- e : Circle                     -\r\n");
	printf("%s","- f : Ellipse                    -\r\n");
	printf("%s","- g : Setcolor(_WHITE)           -\r\n");
	printf("%s","- h : Setcolor(_BLACK)           -\r\n");
	printf("%s","- i : Backlight ON               -\r\n");
	printf("%s","- j : Backlight OFF              -\r\n");
	printf("%s","----------------------------------\r\n");
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;

	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000; dly++) ;			// XTAL  ð 

// Port4 : TEXT LCD Data Bus
	P4DIR = 0xff;						// Port1 ALL Output 
// Port5.0 : LCD A0
// Port5.1 : LCD R/W
// Port5.2 : LCD E
// Port5.3 : LCD CS
// Port5.4 : LCD LEDE
// Port5.5 : LCD RST
	P5OUT &= ~0x07;						// LCD RS = R/W\ = E = 0
	P5OUT |= 0x28;						// LCD_CS\ = LEDE = RST\ = 1
	P5DIR = 0x3f;						// Port5.0,1,2 Output 
// Port3.3 : MAX3221 : FORCEOFF : ShotDowb(0)
	P3OUT |= 0x08;						// MAX3221 FORCE OFF = 1
	P3DIR = 0x08;						// Port3.3 Output 
	
// Rsel = 7, DCO = 7, MOD = 0, DCOR = 0 TA = 25 :: DCO ִ ļ (4.4 - 5.4Mhz)
// XTX  : Low Freqency
// DIVx : ACLK = LXFTCLK(32.768KHz)
// Register Select : 7
	BCSCTL1 = XT2OFF + RSEL2 + RSEL1 + RSEL0;
	DCOCTL = 0xe0;						// DCO Max Freqency
}

// ================================   =================================
// [μ] long baud
// Item1: Ʈ (300 - 9600Bps)
// [] ACLK(32.768KHz)
// ----------------------------------------------------------------------------
void com_set(long baud)
{
// UART Mode,8Bit Data, NON Parity, 1 STOP
	UCTL0 = CHAR;
	UTCTL0 = SSEL0;						// Source Clock UCLK = ACLK
	switch(baud){
		case 1200: UBR00 = 0x1b;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x03;			// Modulation Control Register
			   break;
		case 2400: UBR00 = 0x0d;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x6b;			// Modulation Control Register
			   break;
		case 4800: UBR00 = 0x06;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x6f;			// Modulation Control Register
			   break;
		case 9600: UBR00 = 0x03;			// Baud Rate Register Low
			   UBR10 = 0x00;			// Baud Rate Register High
			   UMCTL0 = 0x4a;			// Modulation Control Register
			   break;
	}
	ME1 |= UTXE0 + URXE0;					// Enabled USART0 TXD/RXD
	IE1 |= URXIE0;						// Enabled USART0 RX interrupt
	P3SEL |= 0x30;						// P3.4,5 = USART0 TXD/RXD
	P3DIR |= 0x10;						// P3.4 output direction
}

// =============================== 1 Ʈ ۽ ==============================
// [μ] int c
// Item1:  (0 - ffh)
// [] printf()Լ  putchar() .
// ----------------------------------------------------------------------------
int putchar(int c)
{
	while(!(IFG1 & UTXIFG0));				// USART0 TX buffer ready?
	TXBUF0 = c;						// RXBUF0 = send data
	return(c);
}

// =============================== 1Ʈ ۽ ===============================
// [μ] unsigned char datac
// Item1:  (0 - ffh)
// ----------------------------------------------------------------------------
void putchar_0(unsigned char datac)
{
	while(!(IFG1 & UTXIFG0));				// USART0 TX buffer ready?
	TXBUF0 = datac;						// RXBUF0 = send data
}

// ================================ Ʈ ۽ ===============================
// [μ] unsigned char dbuf
// Item1:   ڿ
// ----------------------------------------------------------------------------
void puts_0(unsigned char dbuf[])
{
unsigned char ch;
int i = 0;

	ch = dbuf[i++];
	while(ch != 0){
		putchar_0(ch);					// 1 send
		ch = dbuf[i++];
	}
}

// ============================== UART0 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt (UART0RX_VECTOR)usart0_rx(void)
{
	com0_rx_data = RXBUF0;					//   
	com0_rx_eflg = 1;					//  Ϸ ÷ SET
}

// =============================== LCD ȭ  ===============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Clrscr(void)
{
	Cleardevice();						// ȭ 
}

// =============================== LCD ȭ  ===============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Cleardevice(void)
{
int i,page,col;
	
	P4DIR = 0xff;						// LCD_D[0..7] Output Mode Set
	for(page = 0; page < 8; page++){			// Page0-7
		GLCD_Command(PAGE_ADDRESS+page);		// page set
		GLCD_Command(COLUMN_ADDRESS_HI);		// Column set
		GLCD_Command(COLUMN_ADDRESS_LO);

		P4OUT = 0x00;					// Clear Data		
		P5OUT &= ~0x04;					// PORT5.2 :: LCD_E = 0
		P5OUT |= 0x01;					// PORT5.0 :: LCD RS = 1 :: Data Set
		P5OUT &= ~0x08;					// PORT5.3 = LCD_CS1 = 0
		P5OUT &= ~0x02;					// PORT5.1 :: LCD_R/W\ = Write
		for(col = 0; col < 128; col++){			// column0-127
			P5OUT |= 0x04;				// PORT5.2 :: LCD_E = 1
			for(i = 0; i < 2; i++);			// ð 
			P5OUT &= ~0x04;				// PORT5.2 :: LCD_E = 0
			for(i = 0; i < 2; i++);			// ð 
		} 
		P5OUT |= 0x08;					// PORT5.3 = LCD_CS1 = 1
	}
	_screen_curx = _screen_cury = 0;
}

// ============================= ׷ ǥ  ==============================
// [μ] int x,int y
// Item1: x pos(0 - 127)
// Item2: y pos(0 - 63)
// -----------------------------------------------------------------------------
void Gotoxy(int x,int y)
{
	if(x >= 0 && x < 128){					// X ʰ ˻
		if(y >= 0 && y < 64){				// Y ʰ ˻
			_screen_curx = x;
			_screen_cury = y;
		}
	}
}

// ======================= ȭ鿡 ؽƮ ǥ  ===========================
// [μ] int x,int y
// Item1  x pos(1 - 16)
// Item2  y pos(1 - 4)
// [] _screen_curx,_screen_cury
// -----------------------------------------------------------------------------
void Gotoxyt(int x,int y)
{
int x1 = (x-1) * 8,y1;

	y1 = (y-1) * 16;
	if(x1 >= 0 && x1 < 128){
		if(y1 >= 0 && y1 < 64){
			_screen_curx = x1;
			_screen_cury = y1;
		}
	}
}

// =============================== ڻ  ===============================
// [μ] char color
// Item1: 0(off),1(on)
// -----------------------------------------------------------------------------
void Backlight_Ctrl(char sts)
{
	if(sts == 0) P5OUT &= ~0x10;				// BackLight off
	else P5OUT |= 0x10;					// BackLight on
}

// =============================== Ʈ  ===============================
// [μ] char sts
// Item1: ڻ(_WHITE,_BLACK)
// -----------------------------------------------------------------------------
void Setcolor(char color)
{
	_screen_color = color;					// ڻ 
}

// ============================== ѹڸ  Ѵ. ==========================
// [μ] unsigned c
// Item1:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putch(unsigned c)
{
	_Putch(c&0xff);						// 1Ʈ ڸ ǥ
}

// ================  ׷ ǥ ѹڸ  Ѵ. ===================
// [μ] int x
//	  int y
//	  unsigned c
// Item1:    ġ(0 - 127)
// Item2:    ġ(0 - 63)
// Item3:  ((ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxy(int x,int y,unsigned c)
{
	Gotoxy(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ===================  ؽƮ ǥ ѹڸ  Ѵ. ================
//  [μ] int x
//	   int y
//	   unsigned c
//  Item1:    ġ(1 - 16)
//  Item2:    ġ(1 - 4)
//  Item3:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxyt(int x,int y,unsigned c)
{
	Gotoxyt(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ====================  Ŀ ġ  ڿ  Ѵ. ==================
//  [μ] const char *str
//  Item1:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Puts(const char *str)
{
unsigned char byte1st = 0,c;
unsigned datau,i = 0;

	Han_Conv((char*)str);					// ϼ  ȯ
	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
//	while((c = *str++) != 0){				// 쿡 ϼ->  
		if(byte1st){
			datau = ((unsigned)byte1st << 8) | (unsigned)c;
			_Putch(datau);				// ѱ ڸ ǥ
			byte1st = 0;                    	
		}                                       	
		else if(c & 0x80){                      	
			byte1st = c;				// ѱ Ÿ 
		}                                       	
		else{                                   	
			if(c == 0x0a){				//  ǵ
				_Putch(0x0d);           	
				_Putch(0x0a);           	
			}                               	
			else _Putch(c); 			//  ڸ ǥ
		}
	}
}

// ==================  ׷ ġ  ڿ  Ѵ. ==================
//  [μ] int x
//	   int x
//	   const char *str
//  Item1: Ŀ  ǥ(0 - 127)
//  Item2: Ŀ  ǥ(0 - 63)
//  Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxy(int x,int y,const char *str)
{
	Gotoxy(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ================  ؽƮ ġ  ڿ  Ѵ. ====================
//  [μ] int x
//	   int y
//	   const char *str
//  Item1: Ŀ  ǥ(1 - 16)
//  Item2: Ŀ  ǥ(1 - 4)
//  Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxyt(int x,int y,const char *str)
{
	Gotoxyt(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ============== ׷ LCD  ġ   ׸ ==============
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Line(int x1,int y1,int x2,int y2)
{
int i,vdx,vdy,vix,viy,vinc,plot,plotx,ploty,x = 0,y = 0;

	vdx = x2 - x1;						// vdx = x2 - x1
	vdy = y2 - y1;						// vdy = y2 - y1
	vix = abs(vdx);						// vix = |vdx|
	viy = abs(vdy); 					// vix = |vdx|
	if(vix > viy) vinc = vix;				// vinc = vix ? viy;
	else vinc = viy;

	plotx = x1;
	ploty = y1;
	Putpixel(plotx,ploty,_screen_color);
	for(i = 0; i <= vinc; i++){
		x += vix;
		y += viy;
		plot = 0;
		if(x > vinc){
			x -= vinc;
			if(vdx > 0) plotx++;
			if(vdx < 0) plotx--;
			plot = 1;
		}
		if(y > vinc){
			y -= vinc;
			if(vdy > 0) ploty++;
			if(vdy < 0) ploty--;
			plot = 1;
		}
		if(plot)Putpixel(plotx,ploty,_screen_color);
	}
}

// ================================== ڽ ׸ ==============================
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Rectangle(int x1,int y1,int x2,int y2)
{
	Line(x1,y1,x2,y1);
	Line(x1,y1,x1,y2);
	Line(x1,y2,x2,y2);
	Line(x2,y1,x2,y2);
}

// ============================== ä ڽ ׸ ===========================
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Rectanglefill(int x1,int y1,int x2,int y2)
{
	for( ; y1 <= y2; y1++) Line(x1,y1,x2,y1);
}

// ===============================  ׸ ===================================
// [μ] int xx
//	  int yy
//	  float radius
// Item1:  xǥ
// Item2:  yǥ
// Item3: 
// -----------------------------------------------------------------------------
void Circle(int xx,int yy,int radius)
{
int y = radius,d = 3-(y*2),x = 0;

	while(x < y){
		Putpixel(xx+x,yy+y,_screen_color);
		_Plotcircle(xx,yy,x,y);				// Ī Ŵ
		if(d < 0) d += (x*4+6);
		else{
			d += ((x-y)*4+10);
			y--;
		}
		x++;
	}
	if(x == y) Putpixel(xx+x,yy+y,_screen_color);
}

// ====================== ׸⿡ Ǵ Ī Լ ========================
void _Plotcircle(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx-y,yy+x,_screen_color);
	Putpixel(xx+y,yy-x,_screen_color);
	Putpixel(xx-y,yy-x,_screen_color);
	Putpixel(xx+y,yy+x,_screen_color);
}

// ================================== Ÿ ׸ ===============================
// [μ] int xx
//	  int yy
//	  int a0
//	  int b0
// Item1:  xǥ
// Item2:  yǥ
// Item3:  ݰ
// Item4:  ݰ
// -----------------------------------------------------------------------------
void Ellipse(int xx,int yy,int a0,int b0)
{
int x = 0,y = b0;
long a = a0,b = b0,a2 = a*a,a22 = 2*a2,b2 = b*b,b22 = 2*b2,d,dx,dy;

	d = b2-a2*b+a2/4L;
	dx=0L;
	dy=a22*b;
	while(dx < dy){
		symmetry4(xx,yy,x,y);
		if(d > 0){
			y--;
			dy-=a22;
			d-=dy;
		}
		x++;
		dx+=b22;
		d+=b2+dx;
	}
	d+=(3*(a2-b2)/2L-(dx+dy))/2L;
	while(y >= 0){
		symmetry4(xx,yy,x,y);
		if(d < 0){
			x++;
			dx+=b22;
			d+=dx;
		}
		y--;
		dy-=a22;
		d+=a2-dy;
	}
}

// ======================= Ÿ ׸⿡ Ǵ Ī Լ =====================
void symmetry4(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx+x,yy+y,_screen_color);
}

// =============================== ȭ鿡   ============================
// [μ] int x,int y,int color
// Item1:  ũ(0 - 127)
// Item2:  ũ(0 - 63)
// Item3: (_WHITE,_BLACK)
// -----------------------------------------------------------------------------
void Putpixel(int x,int y,char color)
{
unsigned char uch;
int page;
int mask_data = 0x01;

// page  BITġ 
	page = y >> 3;						// page = y / 8
	mask_data = mask_data << (y & 0x07);			// mask_data = 1 << (y%8)		

// DD RAM ġ 
	GLCD_Command(PAGE_ADDRESS + page);			// page set
	GLCD_Command(COLUMN_ADDRESS_HI + (x >> 4));		// x address set
	GLCD_Command(COLUMN_ADDRESS_LO + (x & 0x0f));
//  
	uch = GLCD_Dread();					//   dummy
	uch = GLCD_Dread();					//  
	if(color == _BLACK){
		mask_data = ~mask_data;				// mask data  0000 0001 -> 1111 1110
		uch = uch & mask_data;				// ش BIT 
	}
	else uch |= mask_data;

// DD RAM ġ 
	GLCD_Command(PAGE_ADDRESS + page);			// page set
	GLCD_Command(COLUMN_ADDRESS_HI + (x >> 4));		// x address set
	GLCD_Command(COLUMN_ADDRESS_LO + (x & 0x0f));
//  
	GLCD_Dwrite(uch);					//  write
}

// ========================= ȭ ι 1BYTE  =======================
// [μ] int x,int y,unsigned char data,char color
// item1:  ũ(0 - 127)
// item2:  ũ(0 - 63)
// item3: Ÿ
// item4: 
// ------------------------------------------------------------------------------
void Putpixelb(int x,int y,unsigned char datac,char color)
{
unsigned char uch;
int page,s_cnt;
unsigned mask_data = 0xff,datau;

// page  BITġ 
	page = y >> 3;						// page = y / 8
	s_cnt = y & 0x07;					// shift cnt = y%8		
	mask_data = mask_data << s_cnt;				// mask data  0111 1101 -> 1111 1010
	datau = datac << s_cnt;					// ǥ  

// DD RAM ġ 
	GLCD_Command(PAGE_ADDRESS + page);			// page set
	GLCD_Command(COLUMN_ADDRESS_HI + (x >> 4));		// x address set
	GLCD_Command(COLUMN_ADDRESS_LO + (x & 0x0f));
	
//  
	uch = GLCD_Dread();					//   dummy
	uch = GLCD_Dread();					//  
	if(color == _BLACK) uch = uch & ~datau;			// NEW  & ~
	else{
		uch = uch & ~mask_data;				//  SKIP
		uch = uch | datau;				// NEW  OR 
	}
// DD RAM ġ 
	GLCD_Command(PAGE_ADDRESS + page);			// page set
	GLCD_Command(COLUMN_ADDRESS_HI + (x >> 4));		// x address set
	GLCD_Command(COLUMN_ADDRESS_LO + (x & 0x0f));
//  
	GLCD_Dwrite(uch);					//  write
	if(s_cnt != 0 && page < 8){				// 1Byte  ǥ  page 0-7 ʰ ?
		datau = datau >> 8;				//   ε
		mask_data = mask_data >> 8;			//  ũ ε
// DD RAM+1 ġ 
		GLCD_Command(PAGE_ADDRESS + page+1);		// page set
		GLCD_Command(COLUMN_ADDRESS_HI + (x >> 4));	// x address set
		GLCD_Command(COLUMN_ADDRESS_LO + (x & 0x0f));
//  
		uch = GLCD_Dread();				//   dummy
		uch = GLCD_Dread();				//  
		if(color == _BLACK) uch = uch & ~datau;		// NEW  & ~
		else{
			uch = uch & ~mask_data;			//  SKIP
			uch = uch | datau;			// NEW  OR 
		}
// DD RAM+1 ġ 
		GLCD_Command(PAGE_ADDRESS + page+1);		// page set
		GLCD_Command(COLUMN_ADDRESS_HI + (x >> 4));	// x address set
		GLCD_Command(COLUMN_ADDRESS_LO + (x & 0x0f));
//  
		GLCD_Dwrite(uch);				//  write
	}
}

// ========================= Ʈ     =========================
// [μ] unsigned int	c
// Item1:  
// ------------------------------------------------------------------------------
void _Putch(unsigned int c)
{
unsigned char *image;
int ch,i,curx1 = _screen_curx,cury1 = _screen_cury;

	if(c & 0x8000){						// ѱ ڵ Ÿ
		image = _GetHanImage(c);			// ѱ  
		for(i = 0; i < 16; i++){
			ch = *image++;				// ѱ  
			Putpixelb(curx1,cury1,ch,_screen_color);
			if(curx1 < 127) curx1++;		// Ŀ   
		}
		cury1 = _screen_cury+8;				// Yǥ+8
		if(cury1 < 64){
			curx1 = _screen_curx;			// Xǥ 
			for(i = 0; i < 16; i++){
				ch = *image++;			// Data Read
				Putpixelb(curx1,cury1,ch,_screen_color);
				if(curx1 < 127) curx1++;	// Ŀ   
			}
		}
		_screen_curx += 16;				// Ŀ   
		if(_screen_curx >= 128){
			_screen_curx = 0;
			_screen_cury += 16;			// Ŀ   
			if(_screen_cury >= 64) _screen_cury = 0;
		}
	}
	else{							//  ڵ Ÿ
		if(c == 0x0a){
			_screen_cury += 16;			// Ŀ   
			if(_screen_cury >= 64) _screen_cury = 0;// Ŀ   ˻
		}
		else if(c == 0x0d) _screen_curx = 0;		// Carrage Return
		else{
			image = _GetAscImage(c);		//   
			for(i = 0; i < 8; i++){
				ch = *image++;			// Data Read
				Putpixelb(curx1,cury1,ch,_screen_color);
				if(curx1 < 127) curx1++;	// Ŀ   
			}
			cury1 = _screen_cury+8;			// Yǥ+8
			if(cury1 < 64){
				curx1 = _screen_curx;		// Xǥ 
				for(i = 0; i < 8; i++){
					ch = *image++;		// Data Read
					Putpixelb(curx1,cury1,ch,_screen_color);
					if(curx1 < 127) curx1++;// Ŀ   
				}
			}
			_screen_curx += 8;			// Ŀ   
			if(_screen_curx >= 128){
				_screen_curx = 0;
				_screen_cury += 16;		// Ŀ   
				if(_screen_cury >= 64) _screen_cury = 0;
			}
		}
	}
}

// ======================== ѱ Ʈ Ÿ   ======================
//  [μ] unsigned c
//  Item1: ȯ Ÿ
//   : ȯ  
// ------------------------------------------------------------------------------
void *_GetHanImage(unsigned c)
{
unsigned h, h1, h2, h3, type1, type2, type3, pos;

	static char idxtbl1[] = {				// ʼ ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16, 17, 18, 19,  0,  0,  0,
		 0,  0,  0,  0,  0,  0,  0,  0
	};
	static char idxtbl2[] = {				// ߼ ε ̺
		 0,  0,  0,  1,  2,  3,  4,  5,
		 0,  0,  6,  7,  8,  9, 10, 11,
		 0,  0, 12, 13, 14, 15, 16, 17,
		 0,  0, 18, 19, 20, 21,  0,  0
	};
	static char idxtbl3[] = {				//  ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16,  0, 17, 18, 19, 20, 21,
		22, 23, 24, 25, 26, 27,  0,  0
    };
	static char type1tbl_no[]  = {				// ߼  ʼ /ħ 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3,
		3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0
	};
	static char type1tbl_yes[] = {				// ߼  ʼ /ħ 
		5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7,
		7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5
	};
	static char type3tbl[] = {				// ߼   
		0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0,
		2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1
	};

	h1 = (c >> 10) & 0x1F;					// ʼ ڵ
	h2 = (c >> 5)  & 0x1F;					// ߼ ڵ
	h3 = c	       & 0x1F;					//  ڵ
                                        			
	h1 = idxtbl1[h1];					// ʼ ε ڵ
	h2 = idxtbl2[h2];					// ߼ ε ڵ
	h3 = idxtbl3[h3];					//  ε ڵ

	type1 = h3 ? type1tbl_yes[h2] : type1tbl_no[h2];
	type2 = ((h1 == 0 || h1 == 1 || h1 == 16) ? 0 : 1) + (h3 ? 2 : 0);
	type3 = type3tbl[h2];

	if(h1){
		h = h1-1;					// ʼ[8][19][32] -> ʼ[152][32]
		pos = type1*19;
		memcpy(ib, HanFont1[pos+h], 32);
	}
	else memset(ib, 0, 32);
	if(h2){
		h = h2-1;
		pos = type2*21;
		_memor(ib, HanFont2[pos+h], 32);		// ߼[4][21][32] -> ߼[84][32]
	}
	if(h3){
		h = h3-1;
		pos = type3*27;
		_memor(ib, HanFont3[pos+h], 32);		// [4][27][32] -> [108][32]
	}
	return ib;
}

// ======================  ѱ Ʈ Ѵ. ==========================
//  [μ] unsigned char *s1
//	   unsigned char *s2
//	   int	len
//  Item1:  
//  Item2: ε 
//  Item3: 
// ------------------------------------------------------------------------------
void _memor(unsigned char *s1,const unsigned char *s2, int len)
{
	do{	
		*s1++ |= *s2++;
	}while (--len);
}

// =======================  Ʈ  ε ===============================
//  [μ] char c
//  Item1: ȯ Ÿ
//   : ȯ  
// -----------------------------------------------------------------------------
unsigned char* _GetAscImage(int c)
{
int i;

        for(i = 0; i < 16; i++) ascii_fbuf[i] = AscFont16[c][i];
	return ascii_fbuf;
}

// ===================== ϼ ڵ带  ȯ.=========================
// [μ] char *buf
// Item1: ȯ ڿ 
//  : ȯ   -> han_conv_buf[101]
// -----------------------------------------------------------------------------
void Han_Conv(char *buf)
{
unsigned char temp[2];
int  i,j,len;
unsigned lpos,code;

	len = strlen(buf);
	for(i = j = 0; i < len; i++){
		temp[0] = buf[i];
		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
			temp[1] = buf[++i];
			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
				code = Conv_Tbl[lpos];		// Data Read
				han_conv_buf[j++] = (char)(code >> 8);
				han_conv_buf[j++] = (char)(code & 0xff);
			}
		}
		else if(temp[0] == 0xa3){
			temp[1] = buf[++i];
			han_conv_buf[j++] = 0xda;
			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
		}
		else if(temp[0] == 0xa1){
			temp[1] = buf[++i];
			if(temp[1] == 0xa1){
				han_conv_buf[j++] = 0xd9;
				han_conv_buf[j++] = 0x31;
			}
			else{
				han_conv_buf[j++] = temp[0];
				han_conv_buf[j++] = temp[1];
			}
		}
		else han_conv_buf[j++] = temp[0];
	}
	han_conv_buf[j] = 0;					// ڿ  ǥ
}

// ============================ ׷ LCD ʱȭ ==============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void GLCD_Init(void)
{
// ׷ LCD 
	P5OUT &= ~0x20;						// Port5.5(RST\) = 0
	LCD_delay(200);						// reset ð 
	P5OUT |= 0x20;						// Port5.5(RST\) = 1
	
	GLCD_Command(LCD_RESET);
	GLCD_Command(V5_VOLTAGE_RATIO+3);  
	GLCD_Command(ALL_POWER_ON);  
	GLCD_Command(LCD_CONTRAST);
	GLCD_Command(0x32);					//LCD CONTRAST 
	GLCD_Command(VERTICAL_REVERSE);
//	GLCD_Command(HORIZONTAL_REVERSE);
	GLCD_Command(DISPLAY_ON);

	Cleardevice();						// LCD Clear

	Backlight_Ctrl(1);					// LCD BACKlight ON
}

// =================================== BUSY Check ============================
// [μ] void
// ---------------------------------------------------------------------------
void GLCD_Busy(void)
{
unsigned char i,ch;

	P4DIR = 0x00;						// LCD_D[0..7] INPUT Mode Set
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT &= ~0x01;						// PORT5.0 :: LCD RS = 0 :: Instruction Set
	P5OUT |= 0x02;						// PORT5.1 :: LCD_R/W\ = Read

	P5OUT &= ~0x08;						// PORT5.3 = LCD_CS = 0
	P5OUT |= 0x04;						// PORT5.2 :: LCD_E = 1
	for(i = 0; i < 3; i++);					// delay
	ch = P4IN & 0x80;					// LCD DATA Read :: BUSY BIT
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT |= 0x08;						// PORT5.3 = LCD_CS = 1
	for(i = 0; i < 3; i++);	
	while(ch == 0x80){
		P5OUT &= ~0x08;					// PORT5.3 = LCD_CS = 0
		P5OUT |= 0x04;					// PORT5.2 :: LCD_E = 1
		for(i = 0; i < 3; i++);	
		ch = P4IN & 0x80;				// LCD DATA Read :: BUSY BIT
		P5OUT &= ~0x04;					// PORT5.2 :: LCD_E = 0
		P5OUT |= 0x08;					// PORT5.3 = LCD_CS = 1
		for(i = 0; i < 3; i++);	
	}
}

// ============================== COMMAND  write =======================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void GLCD_Command(unsigned char uch)
{
int i;

	GLCD_Busy();						// BUSY Check
	P4DIR = 0xff;						// LCD_D[0..7] Output Mode Set

	P5OUT &= ~0x08;						// PORT5.3 = LCD_CS = 0
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT &= ~0x01;						// PORT5.0 :: LCD RS = 0 :: Instruction Set
	P5OUT &= ~0x02;						// PORT5.1 :: LCD_R/W\ = Write	
	P4OUT = uch;						// PORT4 = uch
	P5OUT |= 0x04;						// PORT5.2 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT |= 0x08;						// PORT5.3 = LCD_CS = 1
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  write ==========================
// [μ] unsigned char uch
// Item1: 
// ---------------------------------------------------------------------------
void GLCD_Dwrite(unsigned char uch)
{
int i;

	GLCD_Busy();						// BUSY Check
	P4DIR = 0xff;						// LCD_D[0..7] Output Mode Set

	P5OUT &= ~0x08;						// PORT5.3 = LCD_CS = 0
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT |= 0x01;						// PORT5.0 :: LCD RS = 1 :: Data Set
	P5OUT &= ~0x02;						// PORT5.1 :: LCD_R/W\ = Write	
	P4OUT = uch;						// PORT4 = uch
	P5OUT |= 0x04;						// PORT5.2 :: LCD_E = 1
	for(i = 0; i < 3; i++);	
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT |= 0x08;						// PORT5.3 = LCD_CS = 1
	for(i = 0; i < 3; i++);					// delay
}

// ===================================  read ===========================
// [μ] void
// [] (0-0xff)
// ---------------------------------------------------------------------------
unsigned char GLCD_Dread(void)
{
unsigned char i,uch;

	GLCD_Busy();						// BUSY Check
	P4DIR = 0x00;						// LCD_D[0..7] INPUT Mode Set

	P5OUT &= ~0x08;						// PORT5.3 = LCD_CS = 0
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT |= 0x01;						// PORT5.0 :: LCD RS = 1 :: Data Set
	P5OUT |= 0x02;						// PORT5.1 :: LCD_R/W\ = Read

	P5OUT |= 0x04;						// PORT5.2 :: LCD_E = 1
	for(i = 0; i < 5; i++);					// delay
	uch = P4IN & 0xff;					// LCD DATA Read
	P5OUT &= ~0x04;						// PORT5.2 :: LCD_E = 0
	P5OUT |= 0x08;						// PORT5.3 = LCD_CS = 1
	for(i = 0; i < 3; i++);	
	return(uch);						//  read
}

// ================================= LCD DELAY ===============================
// [μ] int cnt
// Item1: cnt * 1ms
// ---------------------------------------------------------------------------
void LCD_delay(int cnt)
{
unsigned i,dly;

	for(i = 0; i < cnt; i++){
		for(dly = 0; dly < 970; dly++);			// delay 1ms
	}
}
